Notice
Recent Posts
Recent Comments
Link
일 | 월 | 화 | 수 | 목 | 금 | 토 |
---|---|---|---|---|---|---|
1 | 2 | |||||
3 | 4 | 5 | 6 | 7 | 8 | 9 |
10 | 11 | 12 | 13 | 14 | 15 | 16 |
17 | 18 | 19 | 20 | 21 | 22 | 23 |
24 | 25 | 26 | 27 | 28 | 29 | 30 |
Tags
- 밥먹고
- 메일우유
- 토이프로젝트
- 발더스3
- 나쫌
- 버즈2프로
- 눈알빠지겠네
- 송리단
- 서울제빵소
- 발더스모드
- 누룽지소금빵
- 노노그램
- 잠실새내
- 뜨아거
- LeetCode
- 알고리즘테스트
- 코딩테스트
- 3d퍼즐
- 미앤아이
- 하스스톤
- javascript
- 맛집
- 취미
- 발더스게이트
- 코테
- 게임
- 천등
- 바질토마토뭐시기
- 메탈퍼즐
- DIY
Archives
- Today
- Total
.Zzumbong
[leetCode/JS] 1339. Maximum Product of Splitted Binary Tree 본문
coding test/leetCode
[leetCode/JS] 1339. Maximum Product of Splitted Binary Tree
쭘봉 2022. 12. 10. 15:30난이도 [ 🤔 ] Medium
문제 설명
Given the root
of a binary tree, split the binary tree into two subtrees by removing one edge such that the product of the sums of the subtrees is maximized.
Return the maximum product of the sums of the two subtrees. Since the answer may be too large,
return it modulo 109 + 7
.
Note that you need to maximize the answer before taking the mod and not after taking it.
문제가 좀 복잡한데, 요약하자면
하나의 이진트리를 2개로 나눠서 각각 트리의 합계의 곱이 가장 큰 숫자를 리턴하는 것이다.
입출력 예
Example 1:
Input: root = [1,2,3,4,5,6]
Output: 110
Explanation: Remove the red edge and get 2 binary trees with sum 11 and 10. Their product is 110 (11*10)
Example 2:
Input: root = [1,null,2,3,4,null,null,5,6]
Output: 90
Explanation: Remove the red edge and get 2 binary trees with sum 15 and 6.Their product is 90 (15*6)
Constraints
- The number of nodes in the tree is in the range
[2, 5 * 104]
. 1 <= Node.val <= 104
내 솔루션
- 예제1로 설명하자면 [1, 2, 3, 4, 5, 6]를 DFS로 돌려서 [4, 5, 2, 6, 3, 1] 순서로 서치한다.
- 하위 노드부터 돌면서 자를 수 있는 경우의 수를 잘라서 sums에 저장하는 것이다
- sums = [4, 5, 11, 6, 9, 21]로 잘라진 노드의 합계를 sums에 저장한다.
- 마지막으로 sum은 저장된(잘린) 트리의 합계와 나머지 (total-sum)을 곱해서 가장 큰 수를 return하면 끝난다.
var maxProduct = function(root) {
const sums = [];
const dfs = (node) => {
if(!node) return 0;
const sum = node.val + dfs(node.left) + dfs(node.right);
sums.push(sum);
return sum;
}
const total = dfs(root);
return Math.max(...sums.map(s => (total - s) * s)) % (1e9 + 7);
};
감상평
- DFS 파티구나 생소한 문제였다. 재미있어
'coding test > leetCode' 카테고리의 다른 글
[leetCode/JS] 70. Climbing Stairs (0) | 2022.12.12 |
---|---|
[leetCode/JS] 124. Binary Tree Maximum Path Sum (0) | 2022.12.11 |
[leetCode/JS] 1026. Maximum Difference Between Node and Ancestor (0) | 2022.12.09 |
[leetCode/JS] 872. Leaf-Similar Trees (0) | 2022.12.08 |
[leetCode/JS] 938. Range Sum of BST (0) | 2022.12.07 |
Comments